#
# Immigration Mod
# ImmigrationUtils
# 

from CvPythonExtensions import *

import Popup as PyPopup

import CvUtil

import sys
import PyHelpers
import CvConfigParser
		
import pickle

################# SD-UTILITY-PACK ###################
import SdToolKit
sdEcho         = SdToolKit.sdEcho
sdModInit      = SdToolKit.sdModInit
sdModLoad      = SdToolKit.sdModLoad
sdModSave      = SdToolKit.sdModSave
sdEntityInit   = SdToolKit.sdEntityInit
sdEntityExists = SdToolKit.sdEntityExists
sdGetVal       = SdToolKit.sdGetVal
sdSetVal       = SdToolKit.sdSetVal
			
gc = CyGlobalContext()	

PyPlayer = PyHelpers.PyPlayer
PyGame = PyHelpers.PyGame()
localText = CyTranslator()

# Change the value to True if civilization capital cities should be allowed to 
# spawn immigrant units.
# Default value is False
g_bCapitalCitySpawnImmigrants = False

# Change the value to False if immigrants should not be spawned in cities with 
# an unhappy population.
# Default value is True
g_bUnhappyPopulationCausesImmigration = True

# Increase or decrease the value to change how much the unhappy population 
# value will influence the calculations for spawning an immigration unit.
# Default value is 1
g_iUnhappyPopulationCausesImmigrationWeight = 1

# Change the value to False if immigrants should not be spawned in cities with 
# an unhealthy population.
# Default value is True
g_bUnhealthyPopulationCausesImmigration = True

# Increase or decrease the value to change how much the unhealthy population 
# value will influence the calculations for spawning an immigration unit.
# Default value is 1
g_iUnhealthyPopulationCausesImmigrationWeight = 1

# Change the value to False if immigrants should not be spawned in cities with 
# a starving population.
# Default value is True
g_bStarvingPopulationCausesImmigration = True

# Increase or decrease the value to change how much the starving population 
# value will influence the calculations for spawning an immigration unit.
# Default value is 1
g_iStarvingPopulationCausesImmigrationWeight = 1

# Change the value to False if immigrants should not be spawned in cities with 
# an unpacified population. Cities with an unpacified population are cities 
# that have been recently conquered but continue to have an active resistance.
# Default value is True
g_bUnpacifiedPopulationCausesImmigration = True

# Increase or decrease the value to change how much the unpacified population 
# value will influence the calculations for spawning an immigration unit.
# Default value is 1
g_iUnpacifiedPopulationCausesImmigrationWeight = 1

# Change the value to False if immigrants should not be spawned in cities with 
# a pacified population. Cities with a pacified population are cities that have 
# been conquered and all active resistance has been removed and quashed. Also,
# part of the pacified population continues to be influenced by and identifies 
# with other cultures found in the city.
# Default value is True
g_bPacifiedPopulationCausesImmigration = True

# Increase or decrease the value to change how much the pacified population 
# value will influence the calculations for spawning an immigration unit.
# Default value is 2
g_iPacifiedPopulationCausesImmigrationWeight = 2

# Change the value to True if there should be a limit to the number of active 
# immigrant units per city.
# Default value is False
g_bLimitImmigrantUnitsPerCity = False

# Increase or decrease the value if more or less immigrant units should be 
# allowed per city.
# Default value is 1
g_iMaxImmigrantUnitsPerCity = 1

# Change the value to True if there should be a limit to the number of active 
# immigrant units per civilization.
# Default value is False
g_bLimitImmigrantUnitsPerCivilization = False

# Increase or decrease the value if more or less immigrant units should be 
# allowed per civilization.
# Default value is 1
g_iMaxImmigrantUnitsPerCivilization = 1

# Change the value to True if immigrants should be allowed to ignore closed 
# borders between two civilizations.
# Default value is False
g_bImmigrantsIgnoreClosedBorders = False

# Change the value to False if immigrants should not be spawned in cities where
# a part of the population identifies the culture the current owner of the city
# is at war with.
# Default value is True
g_bWarCausesImmigration = True

# Change the value to False if immigrants should not be spawned when a city 
# is lost by a civilization. When set to True this option enables the 
# simulation of part of the population of a city fleeing.
# Default value is True
g_bCityLossCausesImmigration = True

# Change the value to False if immigrant units should not carry any culture 
# from the city they were created from. The culture immigrants carry depends on
# the reason for their creation. For instance if an immigrant unit is created 
# due to a city being captured by civilization x from civilization y then the 
# immigrant unit would carry culture belonging to civilization y. The amount of
# culture an immigrant unit carries is proportional to the population and 
# culture of the city that created them. So if city A with a population of 10 
# and 12000 culture creates an immigrant unit then the immigrant unit would 
# carry 1/10th of the cities culture. 
# Default value is True
g_bImmigrantsCarryCulture = True

# Change the value to True if immigrant units should carry a mix of the culture
# from the city where they were spawned. The culture they carry will be the 
# same ratio of culture from the city they were spawned from. For example if an 
# immigrant unit is spawned from city A with 10% culture from civilization X 
# and 90% culture from civilization Y then the immigration unit will carry 10% 
# culture from civilization X and 90% culture from civilization Y.
# Default value is False
g_bImmigrantsCarryMixedCulture = False

# Change the value to True if when an immigrant unit is spawned in a city they 
# should take/decrease the appropriate amount of culture from the city that 
# spawns them. 
# Default value is True
g_bImmigrantsDecreaseCulture = True

# Change the value to False if inner civilization immigration should be allowed 
# even if Serfdom has been selected for the labor civic.
# Default value is True
g_bSerfdomPreventsInnerCivilizationImmigration = True

# Change the value to True if immigration should be allowed to cause a to be 
# abandoned if a city has a population of one and an immigrant is generated.
# Default value is False
g_bEnableCityAbandonment = False

# Change the value to False if immigrant units should not carry a religion 
# from the city they were created from.
# Default value is True
g_bImmigrantsCarryReligion = True

# Change the value to True if immigrant units should carry a mix of the 
# religion from the city where they were spawned. 
# Default value is False
g_bImmigrantsCarryMixedReligion = False

# Increase or decrease the value to change the chance that an immigrant unit
# will carry a religion from the city they were created from. Valid values are
# from 1 to 100.
# Default value is 5
g_iChanceImmigrantsCarryReligion = 5

# Increase or decrease the value to change the maximum chance that any city 
# will spawn an immigrant in the game.
# Default value is 10
g_iMaxImmigrationSpawnChance = 10


# Set to True to print out debug messages in the logs
g_bDebug = False

LOG_ONLY = 1
SCREEN_ONLY = 2
LOG_AND_SCREEN = 3

# Change to redirect the debug messages to the logs, screen or both.
g_iDebugMessageTarget = LOG_ONLY

CIVILIZATION_IMMIGRATION_COUNT = "Civilization Immigration Count"
CIVILIZATION_IMMIGRATION_DATA = "Civilization Immigration Data"
CIVILIZATION_IMMIGRANT_HASH = "Civilization Immigrant Hash"
CITY_ORIGINS = "City Origins"
TARGET_PLOT = "Target Plot"
IMMIGRANT_CULTURE = "Immigrant Culture"  
IMMIGRANT_RELIGION = "Immigrant Religion"
TARGET_CITY_SUGGESTION = "Target City Suggestion"

INTERNAL = "Internal"
OPEN_CONTACT = "Open Contact"
CLOSED_CONTACT = "Closed Contact"
ENEMY = "Enemy"
CONQUEST = "Conquest"
UNHAPPINESS = "Unhappiness"
UNHEALTHINESS = "Unhealthiness"
STARVATION = "Starvation"
OCCUPATION = "Occupation"
										
def loadConfigurationData():
	global g_bCapitalCitySpawnImmigrants
	global g_bUnhappyPopulationCausesImmigration
	global g_iUnhappyPopulationCausesImmigrationWeight
	global g_bUnhealthyPopulationCausesImmigration
	global g_iUnhealthyPopulationCausesImmigrationWeight
	global g_bStarvingPopulationCausesImmigration
	global g_iStarvingPopulationCausesImmigrationWeight
	global g_bUnpacifiedPopulationCausesImmigration
	global g_iUnpacifiedPopulationCausesImmigrationWeight
	global g_bPacifiedPopulationCausesImmigration
	global g_iPacifiedPopulationCausesImmigrationWeight
	global g_bLimitImmigrantUnitsPerCity
	global g_iMaxImmigrantUnitsPerCity
	global g_bLimitImmigrantUnitsPerCivilization
	global g_iMaxImmigrantUnitsPerCivilization
	global g_bImmigrantsIgnoreClosedBorders
	global g_bWarCausesImmigration
	global g_bCityLossCausesImmigration
	global g_bImmigrantsCarryCulture
	global g_bImmigrantsCarryMixedCulture
	global g_bImmigrantsDecreaseCulture
	global g_bSerfdomPreventsInnerCivilizationImmigration
	global g_bEnableCityAbandonment
	global g_bImmigrantsCarryReligion
	global g_bImmigrantsCarryMixedReligion
	global g_iChanceImmigrantsCarryReligion
	global g_iMaxImmigrationSpawnChance
	
	config = CvConfigParser.CvConfigParser("Immigration Mod Config.ini")

	if(config != None):
		g_bCapitalCitySpawnImmigrants = config.getboolean("Immigration Mod", "Capital City Spawn Immigrants", False)
		g_bUnhappyPopulationCausesImmigration = config.getboolean("Immigration Mod", "Unhappy Population Causes Immigration", True)
		g_iUnhappyPopulationCausesImmigrationWeight = config.getint("Immigration Mod", "Unhappy Population Causes Immigration Weight", 1)
		g_bUnhealthyPopulationCausesImmigration = config.getboolean("Immigration Mod", "Unhealthy Population Causes Immigration", True)
		g_iUnhealthyPopulationCausesImmigrationWeight = config.getint("Immigration Mod", "Unhealthy Population Causes Immigration Weight", 1)
		g_bStarvingPopulationCausesImmigration = config.getboolean("Immigration Mod", "Starving Population Causes Immigration", True)
		g_iStarvingPopulationCausesImmigrationWeight = config.getint("Immigration Mod", "Starving Population Causes Immigration Weight", 1)
		g_bUnpacifiedPopulationCausesImmigration = config.getboolean("Immigration Mod", "Unpacified Population Causes Immigration", True)
		g_iUnpacifiedPopulationCausesImmigrationWeight = config.getint("Immigration Mod", "Unpacified Population Causes Immigration Weight", 1)
		g_bPacifiedPopulationCausesImmigration = config.getboolean("Immigration Mod", "Pacified Population Causes Immigration", True)
		g_iPacifiedPopulationCausesImmigrationWeight = config.getint("Immigration Mod", "Pacified Population Causes Immigration Weight", 2)

		g_bLimitImmigrantUnitsPerCity = config.getboolean("Immigration Mod", "Limit Immigrant Units Per City", False)
		g_iMaxImmigrantUnitsPerCity = config.getint("Immigration Mod", "Max Immigrant Units Per City", 1)
		g_bLimitImmigrantUnitsPerCivilization = config.getboolean("Immigration Mod", "Limit Immigrant Units Per Civilization", False)
		g_iMaxImmigrantUnitsPerCivilization = config.getint("Immigration Mod", "Max Immigrant Units Per Civilization", 1)

		g_bImmigrantsIgnoreClosedBorders = config.getboolean("Immigration Mod", "Immigrants Ignore Closed Borders", False)

		g_bWarCausesImmigration = config.getboolean("Immigration Mod", "War Causes Immigration", True)

		g_bCityLossCausesImmigration = config.getboolean("Immigration Mod", "City Loss Causes Immigration", True)

		g_bImmigrantsCarryCulture = config.getboolean("Immigration Mod", "Immigrants Carry Culture", True)
		g_bImmigrantsCarryMixedCulture = config.getboolean("Immigration Mod", "Immigrants Carry Mixed Culture", False)
		g_bImmigrantsDecreaseCulture = config.getboolean("Immigration Mod", "Immigrants Decrease Culture", True)
		g_bSerfdomPreventsInnerCivilizationImmigration = config.getboolean("Immigration Mod", "Serfdom Prevents Inner Civilization Immigration", True)
		g_bEnableCityAbandonment = config.getboolean("Immigration Mod", "Enable City Abandonment", False)

		g_bImmigrantsCarryReligion = config.getboolean("Immigration Mod", "Immigrants Carry Religion", True)
		g_bImmigrantsCarryMixedReligion = config.getboolean("Immigration Mod", "Immigrants Carry Mixed Religion", False)
		g_iChanceImmigrantsCarryReligion = config.getint("Immigration Mod", "Chance Immigrants Carry Religion", 5)
		g_iMaxImmigrationSpawnChance = config.getint("Immigration Mod", "Max Immigration Spawn Chance", 10)

		if(g_iUnhappyPopulationCausesImmigrationWeight < 0):
			g_iUnhappyPopulationCausesImmigrationWeight = 1
			
		if(g_iUnhealthyPopulationCausesImmigrationWeight < 0):
			g_iUnhealthyPopulationCausesImmigrationWeight = 1
			
		if(g_iStarvingPopulationCausesImmigrationWeight < 0):
			g_iStarvingPopulationCausesImmigrationWeight = 1
			
		if(g_iUnpacifiedPopulationCausesImmigrationWeight < 0):
			g_iUnpacifiedPopulationCausesImmigrationWeight = 1
			
		if(g_iPacifiedPopulationCausesImmigrationWeight < 0):
			g_iPacifiedPopulationCausesImmigrationWeight = 1
			
		if(g_iMaxImmigrantUnitsPerCity < 0):
			g_iMaxImmigrantUnitsPerCity = 1
			
		if(g_iMaxImmigrantUnitsPerCivilization < 0):
			g_iMaxImmigrantUnitsPerCivilization = 1
			
		if(g_iChanceImmigrantsCarryReligion < 0):
			g_iChanceImmigrantsCarryReligion = 5
		
		if(g_iChanceImmigrantsCarryReligion > 100):
			g_iChanceImmigrantsCarryReligion = 5
			

class ImmigrationUtils:
	
	def __init__(self):
				
		loadConfigurationData()


	# Returns True if the current city the immigrant is on is their target plot,
	# otherwise it will return False.
	def isTargetCity(self, objUnit, objCity):
		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return False
			
		# Return immediately if the unit passed in is invalid
		if(objUnit.isNone()):
			return False

		# Return immediately if the unit isn't an immigrant
		if(objUnit.getUnitType() != gc.getInfoTypeForString("UNIT_IMMIGRANT")):
			return False
	
		# Return immediately if the city passed in is invalid
		if(objCity == None):
			return False
			
		# Return immediately if the city passed in is invalid
		if(objCity.isNone()):
			return False

		iPlayerID = objUnit.getOwner()
		
		# Setup the civilization immigration data if it doesn't exist and return
		if(not sdEntityExists("Immigration Mod", iPlayerID)):
			self.setupImmigrantData(iPlayerID)
			
			return False
			
		objPlayer = gc.getPlayer(iPlayerID)
		
		# Get the civilization immigration data			
		civilizationImmigrationHash = sdGetVal("Immigration Mod", iPlayerID, CIVILIZATION_IMMIGRATION_DATA)
	
		# Get the civilization immigrant hash
		civilizationImmigrantHash = civilizationImmigrationHash[CIVILIZATION_IMMIGRANT_HASH]
									
		# Get the immigrant data hash in the civilization immigration hash
		immigrantDataHash = civilizationImmigrantHash[objUnit.getID()]
	
		strTargetPlot = immigrantDataHash[TARGET_PLOT]	
		
		strCurrentPlot = str(objCity.plot().getX())+"-"+str(objCity.plot().getY())
		
		if(strTargetPlot == strCurrentPlot):
			return True
			
		return False
		
		
	# Finds a new target city for the immigrant unit passed in add sends them 
	# towards that city.
	def findNewImmigrationCity(self, objUnit):
		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return
			
		# Return immediately if the unit passed in is invalid
		if(objUnit.isNone()):
			return

		# Return immediately if the unit isn't an immigrant
		if(objUnit.getUnitType() != gc.getInfoTypeForString("UNIT_IMMIGRANT")):
			return
	
		iPlayerID = objUnit.getOwner()
		
		# Setup the civilization immigration data if it doesn't exist and return
		if(not sdEntityExists("Immigration Mod", iPlayerID)):
			self.setupImmigrantData(iPlayerID)
			
			# Remove the immigrant data from the game
			self.removeImmigrantData(objUnit)
			
			# Kill off the immigrant unit.
			objUnit.kill(False,PlayerTypes.NO_PLAYER)

			return
			
		objPlayer = gc.getPlayer(iPlayerID)
		
		# Get the civilization immigration data			
		civilizationImmigrationHash = sdGetVal("Immigration Mod", iPlayerID, CIVILIZATION_IMMIGRATION_DATA)
	
		# Get the civilization immigrant hash
		civilizationImmigrantHash = civilizationImmigrationHash[CIVILIZATION_IMMIGRANT_HASH]
									
		# Get the immigrant data hash in the civilization immigration hash
		immigrantDataHash = civilizationImmigrantHash[objUnit.getID()]

		strImmigrationTargetSuggestion = immigrantDataHash[TARGET_CITY_SUGGESTION]
		
		objCity = objPlayer.getCity(immigrantDataHash[CITY_ORIGINS])

		# Get the best target city for the immigrants
		objTargetCity = self.getBestTargetCity(objCity, strImmigrationTargetSuggestion)

		# Set the new target plot
		immigrantDataHash[TARGET_PLOT] = str(objTargetCity.plot().getX())+"-"+str(objTargetCity.plot().getY())

		# Debug code - Start
		if(g_bDebug):
			CvUtil.pyPrint("New target for immigrants found: %s" %(objTargetCity.getName()))
		# Debug code - End

		objUnit.getGroup().clearMissionQueue()
		
		# Make the immigrants move towards the intended target city
		objUnit.getGroup().pushMoveToMission(objTargetCity.plot().getX(), objTargetCity.plot().getY())

		# Save the immigrant data hash in the civilization immigration hash
		civilizationImmigrantHash[objUnit.getID()] = immigrantDataHash
	
		civilizationImmigrationHash[CIVILIZATION_IMMIGRANT_HASH] = civilizationImmigrantHash
		
		# Save the updated civiliation immigration hash			
		sdSetVal("Immigration Mod", iPlayerID, CIVILIZATION_IMMIGRATION_DATA, civilizationImmigrationHash )

								
	# Handles the cases when a unit moves from a plot to the plot passed in.
	# If the plot passed in contains a city and the unit passed in is an 
	# immigrant then the unit will join the city and try to affect the cities
	# culture.
	def handleUnitMove(self, objUnit, objPlot):
		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return
			
		# Return immediately if the unit passed in is invalid
		if(objUnit.isNone()):
			return

		# Return immediately if the unit isn't an immigrant
		if(objUnit.getUnitType() != gc.getInfoTypeForString("UNIT_IMMIGRANT")):
			return
						
		# Return immediately if the plot passed in is invalid
		if(objPlot == None):
			return
			
		# Return immediately if the plot passed in is invalid
		if(objPlot.isNone()):
			return
		
		# Get the plot the unit will be on when it finishs it's current mission
		objTargetPlot = objUnit.getGroup().lastMissionPlot()
		
		# If the immigrant unit is heading to a plot with no city then send the 
		# immigrant to a new city.
		if(not objTargetPlot.isCity()):

			# Debug code - Start
			if(g_bDebug):
				CvUtil.pyPrint("Immigrant lost city target, getting new target")
			# Debug code - End
			
			self.findNewImmigrationCity(objUnit)
			
			return	
			
		# Return if the current plot the unit is on is not a
		# city
		if(not objUnit.plot().isCity()):
			return
		
		# Return if the current plot has a city but it isn't the immigrant 
		# units target city.
		if(not self.isTargetCity(objUnit, objUnit.plot().getPlotCity())):
			return
		
		# Get the city on the plot
		objCity = objPlot.getPlotCity()
		
		# Increment the cities population by one
		objCity.changePopulation(1)

		# If the mod is configured to have immigrants carry culture then have
		# the immigrants apply their culture to the city passed in.
		if(g_bImmigrantsCarryCulture):
			self.applyImmigrantCulture(objCity, objUnit)

		# If the mod is configured to have immigrants carry religion then have
		# the immigrants apply their religion to the city passed in.
		if(g_bImmigrantsCarryReligion):
			self.applyImmigrantReligion(objCity, objUnit)
		
		# Remove the immigrant data from the game
		self.removeImmigrantData(objUnit)
		
		# Kill off the immigrant unit.
		objUnit.kill(False,PlayerTypes.NO_PLAYER)


	# Applies the religion carried by the unit passed in to the city passed in.
	def applyImmigrantReligion(self, objCity, objUnit):
		# Return immediately if the city passed in is invalid
		if(objCity == None):
			return

		# Return immediately if the city passed in is invalid
		if(objCity.isNone()):
			return

		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return

		# Return immediately if the unit passed in is invalid
		if(objUnit.isNone()):
			return
		
		# Get the owner ID for the unit passed in
		iPlayerID = objUnit.getOwner()

		# Setup the immigration data for the player if it wasn't previously set
		# and return.
		if(not sdEntityExists("Immigration Mod", iPlayerID)):
			self.setupImmigrantData(iPlayerID)
			return
			
		# Get the civilization immigration data for the player
		civilizationImmigrationHash = sdGetVal("Immigration Mod", iPlayerID, CIVILIZATION_IMMIGRATION_DATA)
	
		# Get the unit religion information
		immigrantReligionList = civilizationImmigrationHash[CIVILIZATION_IMMIGRANT_HASH][objUnit.getID()][IMMIGRANT_RELIGION]
		
		# Go through all of the religions in the list
		for iReligionInfoID in immigrantReligionList:
		
			# Debug code - Start
			if(g_bDebug):
				CvUtil.pyPrint("Adding %s from %s civilization to %s" %(gc.getReligionInfo(iReligionInfoID).getDescription(), gc.getPlayer(objCity.getOwner()).getName(), objCity.getName()))
			# Debug code - Start

			# Apply the immigrants religion to the city's plot.
			objCity.setHasReligion(iReligionInfoID, True, True, True)
			
			
	# Applies the culture carried by the unit passed in to the city passed in.
	def applyImmigrantCulture(self, objCity, objUnit):
		# Return immediately if the city passed in is invalid
		if(objCity == None):
			return

		# Return immediately if the city passed in is invalid
		if(objCity.isNone()):
			return

		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return

		# Return immediately if the unit passed in is invalid
		if(objUnit.isNone()):
			return
		
		# Get the owner ID for the unit passed in
		iPlayerID = objUnit.getOwner()

		# Setup the immigration data for the player if it wasn't previously set
		# and return.
		if(not sdEntityExists("Immigration Mod", iPlayerID)):
			self.setupImmigrantData(iPlayerID)
			return
			
		# Get the civilization immigration data for the player
		civilizationImmigrationHash = sdGetVal("Immigration Mod", iPlayerID, CIVILIZATION_IMMIGRATION_DATA)
	
		# Get the unit culture information
		cultureDataHash = civilizationImmigrationHash[CIVILIZATION_IMMIGRANT_HASH][objUnit.getID()][IMMIGRANT_CULTURE]
		
		# Go through all of the players in the culture hash
		for playerID in cultureDataHash.keys():
		
			# Continue if the current player ID is invalid
			if(playerID < 0):
				continue
			
			# Debug code - Start
			if(g_bDebug):
				CvUtil.pyPrint("Adding %s culture from %s civilization to %s" %(cultureDataHash[playerID], gc.getPlayer(playerID).getName(), objCity.getName()))
			# Debug code - Start

			# Apply the immigrants culture to the city's plot.
			objCity.plot().changeCulture(playerID, cultureDataHash[playerID], True)


	# Pushes the move mission back on to the immigrant unit passed in.
	def retargetImmigrant(self, objUnit):
	
		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return

		# Return immediately if the unit passed in is invalid
		if(objUnit.isNone()):
			return

		# Return if the unit isn't an immigrant			
		if(objUnit.getUnitType() != gc.getInfoTypeForString("UNIT_IMMIGRANT")):
			return
		
		iPlayerID = objUnit.getOwner()
			
		# Setup the civilization immigration data if it doesn't exist
		if(not sdEntityExists("Immigration Mod", iPlayerID)):
			self.setupImmigrantData(iPlayerID)

		# Get the civilization immigration data			
		civilizationImmigrationHash = sdGetVal("Immigration Mod", iPlayerID, CIVILIZATION_IMMIGRATION_DATA)

		civilizationImmigrantHash = civilizationImmigrationHash[CIVILIZATION_IMMIGRANT_HASH]
		
		# get the immigrant data hash in the civilization immigration hash
		immigrantDataHash = civilizationImmigrantHash[objUnit.getID()]

		(iX, iY) = immigrantDataHash[TARGET_PLOT].split("-")
		
		objUnit.getGroup().clearMissionQueue()
		
		# Make the immigrants move towards the intended target city
		objUnit.getGroup().pushMoveToMission(int(iX), int(iY))


	# Generates an immigrant and adds the immigrant to the game. Returns True 
	# if an immigrant was generated by the city passed in, False otherwise.
	def generateImmigrant(self, objCity, bCityConquered):

		# Return False immediately if the city passed in is invalid
		if(objCity == None):
			return False

		# Return False immediately if the city passed in is invalid
		if(objCity.isNone()):
			return

		# Get the player object from the ID of the owner of the city
		objPlayer = gc.getPlayer(objCity.getOwner())
		
		# Check to see if the city can generate an immigrant
		bCreated = self.canCityGenerateImmigrant(objCity)

		# Return False if the city cannot generate an immigrant.
		if(not bCreated):
			return False
			
		# Get the reason for the immigration and the suggested target city.
		(strImmigrationReason, strImmigrationTargetSuggestion) = self.getImmigrationReason(objCity)

		# If the city passed in was conquered then set the immigration reason 
		# and target suggestion to CONQUEST and ENEMY
		if(bCityConquered and objCity.getPreviousOwner() != gc.getInfoTypeForString("CIVILIZATION_BARBARIAN") and objCity.getPreviousOwner() != gc.getInfoTypeForString("CIVILIZATION_MINOR")):
			strImmigrationReason = CONQUEST
			strImmigrationTargetSuggestion = ENEMY
		
		# Get the plot the city is on
		objPlot = objCity.plot()
		
		# Get the best target city for the immigrants
		objBestTargetCity = self.getBestTargetCity(objCity, strImmigrationTargetSuggestion)

		# Return false if the best target city is invalid
		if(objBestTargetCity == None):
			return False
			
		# Return false if the best target city is invalid
		if(objBestTargetCity.isNone()):
			return False
		
		# Return false if the best target city is the same city that was passed 
		# in.
		if(objBestTargetCity.getOwner() == objCity.getOwner() and objBestTargetCity.getID() == objCity.getID()):
			return False
			
		# Create the actual immigrant unit in the game
		objUnit = objPlayer.initUnit( gc.getInfoTypeForString("UNIT_IMMIGRANT"), objPlot.getX(), objPlot.getY(), UnitAITypes.NO_UNITAI )
		
		# Get the culture data for the immigrant unit using the immigration reason
		immigrantCultureHash = self.getImmigrantCulture(objCity, strImmigrationReason)
		 
		# Get the religion for the immigrant unit
		immigrantReligionList = self.getImmigrantReligion(objCity)
		
		# Remove some of the culture from the city that the immigrants are 
		# taking with them.
		self.removeImmigrantCulture(objCity, immigrantCultureHash)
		
		# Save the immigrant data
		self.saveImmigrantData(objCity, objBestTargetCity, objUnit, immigrantCultureHash, immigrantReligionList, strImmigrationTargetSuggestion)

		# Make the immigrants move towards the intended target city
		objUnit.getGroup().pushMoveToMission(objBestTargetCity.plot().getX(), objBestTargetCity.plot().getY())

		# Kill off the city if the mod is configured to allow city abandonment
		if(g_bEnableCityAbandonment and objCity.getPopulation() == 1):
			objCity.kill()
			
		# Otherwise reduce the population of the city by 1
		elif(objCity.getPopulation() > 1):
			objCity.changePopulation(-1)
	
		# Debug code - Start
		if(g_bDebug):
			CvUtil.pyPrint("Immigrant created at %s because of %s and is heading towards %s" %(objCity.getName(), strImmigrationReason, objBestTargetCity.getName()))
		# Debug code - End
		
		return True


	# Returns a list containing the religion information that the immigrant 
	# will have when leaving their current city and immigrating to their 
	# targetted city.
	def getImmigrantReligion(self, objCity):

		# Return an empty list immediately if the city passed in is invalid
		if(objCity == None):
			return []

		# Return an empty list immediately if the city passed in is invalid
		if(objCity.isNone()):
			return []

		# Return an empty list if the mod is not configured to allow immigrants 
		# to carry religion
		if(not g_bImmigrantsCarryReligion):
			return []

		cityReligionList = []
		immigrantReligionList = []

		# Go through all of the religions in the game
		for i in range(gc.getNumReligionInfos()):
		
			# Append the religion to the list if the city has the religion			
			if(objCity.isHasReligion(i) > 0):
				cityReligionList.append(i)
		
		# If immigrants should only carry a single religion then try to get 
		# that religion and return
		if(not g_bImmigrantsCarryMixedReligion and len(cityReligionList) > 0):
		
			# Calculate the chance to get the religion
			iReligionChance = CyGame().getSorenRandNum(101, "Religion Chance")
	
			# See if the religion is successfully carried by the immigrant if 
			# it was then append it to the immigrant religion list and return
			if(iReligionChance <= g_iChanceImmigrantsCarryReligion):
				immigrantReligionList.append(cityReligionList[CyGame().getSorenRandNum(len(cityReligionList), "Religion Chance")])

				# Debug code - Start
				if(g_bDebug):
					CvUtil.pyPrint("%s carried from %s" %(gc.getReligionInfo(immigrantReligionList[0]).getDescription(), objCity.getName()))
				# Debug code - End

				return immigrantReligionList

		# Go through all the religions in the city				
		for iReligionInfoID in cityReligionList:

			# Calculate the chance to get the religion
			iReligionChance = CyGame().getSorenRandNum(101, "Religion Chance")
	
			# See if the religion is successfully carried by the immigrant if 
			# it was then append it to the immigrant religion list
			if(iReligionChance <= g_iChanceImmigrantsCarryReligion):
				immigrantReligionList.append(iReligionInfoID)
				# Debug code - Start
				if(g_bDebug):
					CvUtil.pyPrint("%s carried from %s" %(gc.getReligionInfo(iReligionInfoID).getDescription(), objCity.getName()))
				# Debug code - End
				
		
		return immigrantReligionList
	
	
	# Returns a dictionary containing the culture information the immigrant 
	# will have when leaving their current city and immigrating to their 
	# targetted city.
	def getImmigrantCulture(self, objCity, strImmigrationReason):
		
		# Return an empty hash immediately if the city passed in is invalid
		if(objCity == None):
			return {}

		# Return an empty hash immediately if the city passed in is invalid
		if(objCity.isNone()):
			return {}
			
		# Return an empty hash if the mod is not configured to allow immigrants 
		# to carry culture
		if(not g_bImmigrantsCarryCulture):
			return {}
						
		immigrantCultureHash = {}

		# Get the population of the city
		iCityPopulation = objCity.getPopulation()

		# Get the total culture of the city
		iTotalCulture = objCity.plot().countTotalCulture()

		# Return an empty dictionary if the total culture is zero
		if(iTotalCulture == 0):
			return {}
			
		#CvUtil.pyPrint("%s %s %s" %(objCity.getName(), iTotalCulture, iCityPopulation))

		# Calculate the amount of culture per population point
		iCulturePerPopulation = iTotalCulture/iCityPopulation

		# Set the culture data if the immigration reason was occupation or conquest
		if(strImmigrationReason in (OCCUPATION, CONQUEST)):
		
			iCultureAmount = iCulturePerPopulation
			
			# If there isn't enough culture then get the total amount of 
			# culture instead
			if(objCity.plot().getCulture(objCity.getPreviousOwner()) < iCulturePerPopulation):
				iCultureAmount = objCity.plot().getCulture(objCity.getPreviousOwner())

			immigrantCultureHash[objCity.getPreviousOwner()] = iCultureAmount
		
			# Debug code - Start
			if(g_bDebug):
				CvUtil.pyPrint("Foreign aliens are leaving %s with %s culture" %(objCity.getName(), iCultureAmount))
			# Debug code - End
				
		# If the mod is configured to allow immigrants to carry mixed culture 
		# then include a part of the culture of all the civilizations exuding 
		# an influence in the city.
		if(g_bImmigrantsCarryMixedCulture):	
		
			# Get the list of players in the game	
			playerList = PyGame.getCivPlayerList()

			# Go through all the players in the list
			for player in playerList:
			
				# If the current player's culture has already been added then 
				# continue
				if(player.getID() in immigrantCultureHash):

					# Debug code - Start
					if(g_bDebug):
						CvUtil.pyPrint("%s out of %s carried from %s civilization" %(immigrantCultureHash[player.getID()], iTotalCulture, player.getCivilizationName()))
					# Debug code - End
					continue
				
				# If the current player has no culture in the city then 
				# continue.
				if(objCity.plot().getCulture(player.getID()) == 0):
					continue
				
				# Get the current players culture in the city	
				iCulture = objCity.plot().getCulture(player.getID())

				# Calculate the percentage of the influence if the current 
				# player's culture over the city
				fCulturePercent	= float(iCulture)/float(iTotalCulture)
				
				# Get the amount of culture to be carried by the immigrant
				iCultureAmount = int(iCulturePerPopulation * fCulturePercent)

				if(iCultureAmount > objCity.plot().getCulture(player.getID())):
					iCultureAmount = objCity.plot().getCulture(player.getID())

				# Continue if the culture is zero
				if(iCultureAmount == 0):
					continue
					
				immigrantCultureHash[player.getID()] = iCultureAmount

				# Debug code - Start
				if(g_bDebug):
					CvUtil.pyPrint("%s out of %s carried from %s civilization" %(immigrantCultureHash[player.getID()], iTotalCulture, player.getCivilizationName()))
				# Debug code - End

		# If the mod is not configured to allow immigrants to carry mixed 
		# culture then have the immigrant carry the most influential culture
		elif(not g_bImmigrantsCarryMixedCulture and len(immigrantCultureHash.keys()) == 0):
			iCultureAmount = iCulturePerPopulation
			
			if(objCity.plot().getCulture(gc.getTeam(objCity.plot().findHighestCultureTeam()).getLeaderID()) < iCulturePerPopulation):
				iCultureAmount = objCity.plot().getCulture(gc.getTeam(objCity.plot().findHighestCultureTeam()).getLeaderID())

			immigrantCultureHash[objCity.getOwner()] = iCultureAmount

			# Debug code - Start
			if(g_bDebug):
				CvUtil.pyPrint("%s out of %s carried from %s civilization" %(immigrantCultureHash[objCity.getOwner()], iCultureAmount, gc.getPlayer(objCity.getOwner()).getName()))
			# Debug code - End
			
		return immigrantCultureHash


	# Removes the culture carried by the immigrant from the city passed in.
	def removeImmigrantCulture(self, objCity, immigrantCultureHash):

		# Return immediately if the mod is not configured to decrease the 
		# culture in the city spawning immigrants	
		if(not g_bImmigrantsDecreaseCulture):
			return
			
		# Return immediately if the city passed in is invalid
		if(objCity == None):
			return 

		# Return immediately if the city passed in is invalid
		if(objCity.isNone()):
			return 
			
		# Return immediately if the immigrantCultureHash passed in is invalid
		if(immigrantCultureHash == None):
			return 
		
		# Go through all the players in the immigrant culture hash and remove 
		# the corresponding culture from the city.	
		for iPlayerID in immigrantCultureHash.keys():
			if(objCity.plot().getCulture(iPlayerID)-immigrantCultureHash[iPlayerID] >= 0):
				objCity.plot().changeCulture(iPlayerID, -immigrantCultureHash[iPlayerID], True)
			else:
				objCity.plot().setCulture(iPlayerID, 0, True)
	
	# Returns the best target city that the immigrants should head towards
	def getBestTargetCity(self, objCity, strImmigrationTargetSuggestion):
		
		# Return None immediately if the city passed in is invalid
		if(objCity == None):
			return None

		# Return None immediately if the city passed in is invalid
		if(objCity.isNone()):
			return None
			
		iWorstImmigrationChance = 99999
		objBestTargetCity = objCity 
		
		# Get the list of possible target cities
		cityList = self.getTargetCityList(objCity, strImmigrationTargetSuggestion)
	
		# Go through the list of possible target cities
		for objCurrentCity in cityList:
		
			# Get the city immigration information
			(iImmigrationChance, iMaxImmigrationAmount) = self.getCityImmigrationInformation(objCurrentCity)

			# Continue if the current city is the city that was passed in
			if(objCity.getID() == objCurrentCity.getID()):
				continue

			if(CyMap().calculatePathDistance(objCity.plot(), objCurrentCity.plot()) == -1):
				CvUtil.pyPrint("%s cannot be reached from %s" %(objCurrentCity.getName(), objCity.getName()))
				continue
								
			# If the current city is a better immigration target then save it
			if(iImmigrationChance < iWorstImmigrationChance):
				iWorstImmigrationChance = iImmigrationChance
				objBestTargetCity = objCurrentCity
			
		return objBestTargetCity
		
		
	# Returns a list of possible target cities for immigration		
	def getTargetCityList(self, objCity, strImmigrationTargetSuggestion):
		
		# Return an empty list immediately if the city passed in is invalid
		if(objCity == None):
			return []

		# Return an empty list immediately if the city passed in is invalid
		if(objCity.isNone()):
			return []

		cityList = []
		
		# Get the owner of the city
		objPlayer = gc.getPlayer(objCity.getOwner())
		
		# Get the team of the owner of the city
		objTeam = gc.getTeam(objPlayer.getTeam())

		metPlayerList = []

		# If the suggestion isn't ENEMY or CONQUEST then include the players 
		# cities as possible immigration targets
		if(strImmigrationTargetSuggestion != ENEMY and strImmigrationTargetSuggestion != CONQUEST):
			metPlayerList.append(objPlayer)
		
		# Get the players in the game	
		playerList = PyGame.getCivPlayerList()

		# Go through the players in the game
		for player in playerList:
		
			# Continue if the current player is the owner of the city passed in
			if(player.getTeamID() == objPlayer.getTeam()):
				continue
				
			# Continue if the current player hasn't met the owner of the city 
			# passed in	
			if(not objTeam.isHasMet(player.getTeamID())):
				continue
			
			# Continue if the owner of the city passed in has met the current 
			# player and they are not at war and if they do not have a open 
			# border treaty and if the mod is configured to not allow 
			# immigrants to cross closed borders
			if(not g_bImmigrantsIgnoreClosedBorders and not objTeam.isOpenBorders(player.getTeamID()) and not objTeam.isAtWar(player.getTeamID())):
				continue
			
			# Set the player list to be the current player if the suggestion 
			# was CONQUEST and the current player is at war with the owner of 
			# the city passed in and if the cities previous owner is the 
			# current player
			if(strImmigrationTargetSuggestion == CONQUEST and objTeam.isAtWar(player.getTeamID()) and objCity.getPreviousOwner() == player.getID()):
				metPlayerList = [player.CyGet()]
				break

			# Continue if the current suggestion is ENEMY and the current 
			# player is not at war with the owner of the city passed in
			if(strImmigrationTargetSuggestion == ENEMY and not objTeam.isAtWar(player.getTeamID())):
				continue
				
			metPlayerList.append(player.CyGet())

		# Go through all the players
		for player in metPlayerList:

			# Go through all the cities belonging to the current player
			for i in range(player.getNumCities()):
			
				# Get the current city
				objCity = player.getCity(i)
				
				# Append the city to the city list if we got a valid city
				if(objCity != None and gc.getPlayer(objCity.getOwner()) != None):
					cityList.append(objCity)
		
		return cityList
		
		
	# Returns True if the city can generate an immigrant False otherwise.		
	def canCityGenerateImmigrant(self, objCity):			
	
		# Return False immediately if the city passed in is invalid
		if(objCity == None):
			return False

		# Return False immediately if the city passed in is invalid
		if(objCity.isNone()):
			return False
		
		# Return False if the current population of the city is one and if the
		# mod is not configured to allow city abandonment
		if(not g_bEnableCityAbandonment and objCity.getPopulation() == 1):
			return False
				
		# Return False if the city passed in is a capital city and the mod is 
		# not configured to spawn immigrants in capital cities
		if(objCity.isCapital() and not g_bCapitalCitySpawnImmigrants):

			# Debug code - Start 
			if(g_bDebug):
				CvUtil.pyPrint("Immigrants cannot spawn in capital cities")
			# Debug code - End
			
			return False

		objPlayer = gc.getPlayer(objCity.getOwner())
		
		# Return False if the mod is configured to prevent 
		if(g_bSerfdomPreventsInnerCivilizationImmigration and objPlayer.isCivic(gc.getInfoTypeForString("CIVIC_SERFDOM")) and objCity.countTotalCulture() > 0 and (objCity.countTotalCulture() - objCity.getCulture(objCity.getOwner())) == 0):
			return False

		# Return False the number of immigrants for the civilization has been reached
		if(self.isCivilizationImmigrantLimitReached(objCity.getOwner())):
			return False

		# Return False the number of immigrants for the city has been reached
		if(self.isCityImmigrantLimitReached(objCity)):
			return False
			
		# Get the immigration information for the city passed in
		(iImmigrationChance, iMaxImmigrationAmount) = self.getCityImmigrationInformation(objCity)

		iImmigrationTest = CyGame().getSorenRandNum(iMaxImmigrationAmount, "Immigration Chance")

		iMaxImmigrationChance = (float(g_iMaxImmigrationSpawnChance)/100.0)*float(iMaxImmigrationAmount)

		if(g_bDebug):
			CvUtil.pyPrint(u"Total immigration chance in %s is: %d/%s or %2.2f%%" %(objCity.getName(), iImmigrationChance, iMaxImmigrationAmount, float(float(iImmigrationChance)/float(iMaxImmigrationAmount))*100.0))
			strTest = "Immigrant Created in %s? %s %s<%s %s<%s %s/%s = %s" %(objCity.getName(), (iImmigrationTest < iImmigrationChance and iImmigrationTest < iMaxImmigrationChance), iImmigrationTest, iImmigrationChance, iImmigrationTest, iMaxImmigrationChance, iImmigrationChance, iMaxImmigrationAmount, float(iImmigrationChance/iMaxImmigrationAmount))
			CvUtil.pyPrint(strTest)
			#return True
		
		
		return (iImmigrationTest < iImmigrationChance and iImmigrationTest < iMaxImmigrationChance)


	# Returns a tuple containing the reason for immigration and a suggestion 
	# for the immigration target city
	def getImmigrationReason(self, objCity):

		# Return an tuple with empty strings immediately if the city passed 
		# in is invalid
		if(objCity == None):
			return ("", "")

		# Return an tuple with empty strings immediately if the city passed 
		# in is invalid
		if(objCity.isNone()):
			return ("", "")

		strImmigrationReason = None
		strImmigrationTargetSuggestion = None
		
		iHighestImmigrationReason = 0
		
		if(g_bUnhappyPopulationCausesImmigration):

			iUnhappinessContributionToImmigration = float(float(objCity.unhappyLevel(0))/(float(objCity.unhappyLevel(0) + objCity.happyLevel()))) * 100 * g_iUnhappyPopulationCausesImmigrationWeight
			
			if(iHighestImmigrationReason < iUnhappinessContributionToImmigration):
				iHighestImmigrationReason = iUnhappinessContributionToImmigration
				strImmigrationReason = UNHAPPINESS
				strImmigrationTargetSuggestion = INTERNAL

		if(g_bUnhealthyPopulationCausesImmigration):
		
			iUnhealthinessContributionToImmigration = float(float(objCity.badHealth(False))/(float(objCity.badHealth(False) + objCity.goodHealth()))) * 100 * g_iUnhealthyPopulationCausesImmigrationWeight

			if(iHighestImmigrationReason < iUnhealthinessContributionToImmigration):
				iHighestImmigrationReason = iUnhealthinessContributionToImmigration
				strImmigrationReason = UNHEALTHINESS
				strImmigrationTargetSuggestion = INTERNAL

		if(g_bStarvingPopulationCausesImmigration and objCity.getYieldRate(YieldTypes.YIELD_FOOD) > 0 and objCity.foodConsumption(False, 0) >= objCity.getYieldRate(YieldTypes.YIELD_FOOD)):

			iStarvationContributionToImmigration = float(objCity.foodConsumption(False, 0)) / float(objCity.getYieldRate(YieldTypes.YIELD_FOOD) + objCity.foodConsumption(False, 0))  * 100 * g_iStarvingPopulationCausesImmigrationWeight

			if(iHighestImmigrationReason < iStarvationContributionToImmigration):
				iHighestImmigrationReason = iStarvationContributionToImmigration
				strImmigrationReason = STARVATION
				strImmigrationTargetSuggestion = INTERNAL

		if(g_bUnpacifiedPopulationCausesImmigration and objCity.countTotalCulture() == 0):
			iUnpacifiedPopulationContributionToImmigration = objCity.getPopulation() * objCity.getOccupationTimer() * 100 * g_iUnpacifiedPopulationCausesImmigrationWeight

			if(iHighestImmigrationReason < iUnpacifiedPopulationContributionToImmigration):
				iHighestImmigrationReason = iUnpacifiedPopulationContributionToImmigration
				strImmigrationReason = OCCUPATION
				strImmigrationTargetSuggestion = ENEMY

			
		if(g_bPacifiedPopulationCausesImmigration and objCity.countTotalCulture() > 0 and objCity.countTotalCulture() - objCity.getCulture(objCity.getOwner())):
			iPacifiedPopulationContributionToImmigration = float(objCity.countTotalCulture() - objCity.getCulture(objCity.getOwner()))/float(objCity.countTotalCulture()) * float(objCity.getPopulation()) * 100 * g_iPacifiedPopulationCausesImmigrationWeight

			if(iHighestImmigrationReason < iPacifiedPopulationContributionToImmigration):
				iHighestImmigrationReason = iPacifiedPopulationContributionToImmigration
				strImmigrationReason = OCCUPATION
				strImmigrationTargetSuggestion = ENEMY

		if(objCity.getPreviousOwner() == gc.getInfoTypeForString("CIVILIZATION_BARBARIAN")):
				strImmigrationReason = UNHAPPINESS
				strImmigrationTargetSuggestion = INTERNAL

		if(objCity.getPreviousOwner() == gc.getInfoTypeForString("CIVILIZATION_MINOR")):
				strImmigrationReason = UNHAPPINESS
				strImmigrationTargetSuggestion = INTERNAL
		
		return (strImmigrationReason, strImmigrationTargetSuggestion)
		
		
	# Returns a tuple containing the immigration chance and max immigration 
	# chance amount for the city passed in.
	def getCityImmigrationInformation(self, objCity):
	
		iImmigrationChance = 0
		iMaxImmigrationAmount = 0

		# Return False immediately if the city passed in is invalid
		if(objCity == None):
			return (iImmigrationChance, iMaxImmigrationAmount)

		# Return False immediately if the city passed in is invalid
		if(objCity.isNone()):
			return (iImmigrationChance, iMaxImmigrationAmount)
			
		# Calculate the unhappy population impact to immigration chance
		if(g_bUnhappyPopulationCausesImmigration):
		
			fUnhappinessHappinessRatio = float(float(objCity.unhappyLevel(0))/(float(objCity.unhappyLevel(0) + objCity.happyLevel())))
			iUnhappinessContributionToImmigration = fUnhappinessHappinessRatio * 100 * g_iUnhappyPopulationCausesImmigrationWeight
			
			iImmigrationChance += iUnhappinessContributionToImmigration
			iMaxImmigrationAmount += 100 * g_iUnhappyPopulationCausesImmigrationWeight
													
		# Calculate the unhealthy population impact to immigration chance
		if(g_bUnhealthyPopulationCausesImmigration):
			fUnhealthinessHealthinessRatio = float(float(objCity.badHealth(False))/(float(objCity.badHealth(False) + objCity.goodHealth())))
			iUnhealthinessContributionToImmigration = fUnhealthinessHealthinessRatio * 100 * g_iUnhealthyPopulationCausesImmigrationWeight
		
			iImmigrationChance += iUnhealthinessContributionToImmigration
			iMaxImmigrationAmount += 100 * g_iUnhealthyPopulationCausesImmigrationWeight

		# Calculate the starving population impact to immigration chance		
		if(g_bStarvingPopulationCausesImmigration):
			if(objCity.getYieldRate(YieldTypes.YIELD_FOOD) > 0 and objCity.foodConsumption(False, 0) >= objCity.getYieldRate(YieldTypes.YIELD_FOOD)):
				fStarvationRatio = float(objCity.foodConsumption(False, 0)) / float(objCity.getYieldRate(YieldTypes.YIELD_FOOD) + objCity.foodConsumption(False, 0)) 
				iStarvationContributionToImmigration = fStarvationRatio * 100 * g_iStarvingPopulationCausesImmigrationWeight

				iImmigrationChance += iStarvationContributionToImmigration
			iMaxImmigrationAmount += 100 * g_iStarvingPopulationCausesImmigrationWeight
		
		# Calculate the unpacified population impact to immigration chance
		if(g_bUnpacifiedPopulationCausesImmigration):
			if(objCity.countTotalCulture() == 0):
				iUnpacifiedPopulationEffect = objCity.getPopulation() * objCity.getOccupationTimer()
				iUnpacifiedPopulationContributionToImmigration = iUnpacifiedPopulationEffect * 100 * g_iUnpacifiedPopulationCausesImmigrationWeight

				iImmigrationChance += iUnpacifiedPopulationContributionToImmigration

			iMaxImmigrationAmount += 100 * g_iUnpacifiedPopulationCausesImmigrationWeight

		# Calculate the pacified population impact to immigration chance
		if(g_bPacifiedPopulationCausesImmigration):
			if(objCity.countTotalCulture() > 0 and objCity.countTotalCulture() - objCity.getCulture(objCity.getOwner())):
				iPacifiedPopulationRatio =  float(objCity.countTotalCulture() - objCity.getCulture(objCity.getOwner()))/float(objCity.countTotalCulture()) * float(objCity.getPopulation())
				iPacifiedPopulationContributionToImmigration = iPacifiedPopulationRatio * 100 * g_iPacifiedPopulationCausesImmigrationWeight

				iImmigrationChance += iPacifiedPopulationContributionToImmigration
		
			iMaxImmigrationAmount += 100 * g_iPacifiedPopulationCausesImmigrationWeight
			
		return (iImmigrationChance, iMaxImmigrationAmount)
		

	# Returns True if the city has reach its immigration limit False otherwise.	
	def isCityImmigrantLimitReached(self, objCity):

		# Return False immediately if the mod is not configured to limit 
		# immigrant units in a city
		if(not g_bLimitImmigrantUnitsPerCity):
			return False

		# Return False immediately if the city passed in is invalid
		if(objCity == None):
			return False

		# Return False immediately if the city passed in is invalid
		if(objCity.isNone()):
			return False

		# Get the owner ID of the city
		iPlayerID = objCity.getOwner()

		# Setup the civilization immigration data if it doesn't exist and 
		# return False
		if(not sdEntityExists("Immigration Mod", iPlayerID)):
			self.setupImmigrantData(iPlayerID)
			return False
		
		# Get the number of immigrants spawned by the city
		iCityImmigrantCount = self.getCityImmigrantCount(objCity)
		
		# Return True if the city has met its immigration limit
		if(iCityImmigrantCount >= g_iMaxImmigrantUnitsPerCity):
			return True
			
		return False
		
	
	# Returns True if the civilization has reach their immigration limit False 
	# otherwise.	
	def isCivilizationImmigrantLimitReached(self, iPlayerID):

		# Return False immediately if the mod is not configured to limit 
		# immigrant units in a civilization
		if(not g_bLimitImmigrantUnitsPerCivilization):
			return False
			
		# Get the instance of the player
		objPlayer = gc.getPlayer(iPlayerID)
		
		# Return False immediately if the player ID passed in was invalid		
		if(	objPlayer == None):
			return False

		# Return False immediately if the player ID passed in was invalid		
		if(	objPlayer.isNone()):
			return False
	
		# Setup the civilization immigration data if it doesn't exist and 
		# return False
		if(not sdEntityExists("Immigration Mod", iPlayerID)):
			self.setupImmigrantData(iPlayerID)
			return False

		# Get the civilization immigration data				
		civilizationImmigrationHash = sdGetVal("Immigration Mod", iPlayerID, CIVILIZATION_IMMIGRATION_DATA)

		# Return True if the mod is configured to limit the number of 
		# immigrants that can exist in a civilization and the limit has been 
		# reached.	
		if(len(civilizationImmigrationHash[CIVILIZATION_IMMIGRANT_HASH].keys()) >= g_iMaxImmigrantUnitsPerCivilization):
			return True

		return False
		
	
	# Returns the number of immigrants spawned from the city passed in.
	def getCityImmigrantCount(self, objCity):
				
		# Return 0 immediately if the city passed in is invalid
		if(objCity == None):
			return 0

		# Return 0 immediately if the city passed in is invalid
		if(objCity.isNone()):
			return 0
			
		iCityImmigrantCount = 0

		# Get the owner ID of the city
		iPlayerID = objCity.getOwner()

		# Setup the civilization immigration data if it doesn't exist and 
		# return 0
		if(not sdEntityExists("Immigration Mod", iPlayerID)):
			self.setupImmigrantData(iPlayerID)
			return 0
		
		# Get the civilization immigration data				
		civilizationImmigrationHash = sdGetVal("Immigration Mod", iPlayerID, CIVILIZATION_IMMIGRATION_DATA)
		
		# Get the immigrant list
		immigrantList = civilizationImmigrationHash[CIVILIZATION_IMMIGRANT_HASH].values()
		
		# Go through all the immigrants in the immigrant list
		for immigrantData in immigrantList:
			
			# If the immigrants city of origin matches the ID of the city 
			# passed in then count the immigrant
			if(immigrantData[CITY_ORIGINS] == objCity.getID()):
				iCityImmigrantCount += 1
		
		return iCityImmigrantCount
		
	
	# Saves the immigrant data in the game
	def saveImmigrantData(self, objCity, objTargetCity, objUnit, cultureDataHash, immigrantReligionList, strImmigrationTargetSuggestion):

		# Return immediately if the city passed in is invalid
		if(objCity == None):
			return

		# Return immediately if the city passed in is invalid
		if(objCity.isNone()):
			return

		# Return immediately if the target city passed in is invalid
		if(objTargetCity == None):
			return

		# Return immediately if the target city passed in is invalid
		if(objTargetCity.isNone()):
			return

		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return

		# Return immediately if the unit passed in is invalid
		if(objUnit.isNone()):
			return

		# Return immediately if the culture data passed in is invalid
		if(cultureDataHash == None):
			return
	
		# Return immediately if the religion data passed in is invalid
		if(immigrantReligionList == None):
			return
	
		# Get the owner ID of the city
		iPlayerID = objCity.getOwner()

		# Setup the civilization immigration data if it doesn't exist
		if(not sdEntityExists("Immigration Mod", iPlayerID)):
			self.setupImmigrantData(iPlayerID)

		# Get the civilization immigration data			
		civilizationImmigrationHash = sdGetVal("Immigration Mod", iPlayerID, CIVILIZATION_IMMIGRATION_DATA)
	
		# Increment the immigrant count for the civilization
		civilizationImmigrationHash[CIVILIZATION_IMMIGRATION_COUNT] += 1
	
		# Construct the immigrant data hash
		immigrantDataHash = {
								CITY_ORIGINS : objCity.getID(), 
								TARGET_PLOT : str(objTargetCity.plot().getX())+"-"+str(objTargetCity.plot().getY()),
								IMMIGRANT_CULTURE : cultureDataHash, 
								IMMIGRANT_RELIGION : immigrantReligionList, 
								TARGET_CITY_SUGGESTION : strImmigrationTargetSuggestion,
							}

		# Get the civilization immigrant hash
		civilizationImmigrantHash = civilizationImmigrationHash[CIVILIZATION_IMMIGRANT_HASH]
									
		# Save the immigrant data hash in the civilization immigration hash
		civilizationImmigrantHash[objUnit.getID()] = immigrantDataHash
	
		civilizationImmigrationHash[CIVILIZATION_IMMIGRANT_HASH] = civilizationImmigrantHash
		
		# Save the updated civiliation immigration hash			
		sdSetVal("Immigration Mod", iPlayerID, CIVILIZATION_IMMIGRATION_DATA, civilizationImmigrationHash )
				
				
	# Removes the unit data passed in from the game
	def removeImmigrantData(self, objUnit):
	
		# Return immediately if the unit passed in is invalid
		if(objUnit == None):
			return

		# Return immediately if the unit passed in is invalid
		if(objUnit.isNone()):
			return
		
		# Get the owner of the unit
		iPlayerID = objUnit.getOwner()

		# Setup the player's game data if it doesn't exist and return immediately
		if(not sdEntityExists("Immigration Mod", iPlayerID)):
			self.setupImmigrantData(iPlayerID)
			return

		# Get the civilization immigration data			
		civilizationImmigrationHash = sdGetVal("Immigration Mod", iPlayerID, CIVILIZATION_IMMIGRATION_DATA)
	
		# Decrement the immigrant count for the civilization
		civilizationImmigrationHash[CIVILIZATION_IMMIGRATION_COUNT] -= 1
											
		# Delete the immigrant data from the civilization hash
		del civilizationImmigrationHash[CIVILIZATION_IMMIGRANT_HASH][objUnit.getID()]

		# Save the updated civiliation immigration hash			
		sdSetVal("Immigration Mod", iPlayerID, CIVILIZATION_IMMIGRATION_DATA, civilizationImmigrationHash )

		
	# Sets up the immigration data for the player ID passed in. Returns True if
	# the data was setup successfully, False otherwise.
	def setupImmigrantData(self, iPlayerID):
		
		# Get the instance of the player
		objPlayer = gc.getPlayer(iPlayerID)
		
		# Return False immediately if the player ID passed in was invalid		
		if(	objPlayer == None):
			return False

		# Return False immediately if the player ID passed in was invalid		
		if(	objPlayer.isNone()):
			return False
			
		civilizationImmigrantHash = {}
		
		civilizationImmigrationHash = {
			CIVILIZATION_IMMIGRATION_COUNT : 0,
			CIVILIZATION_IMMIGRANT_HASH : civilizationImmigrantHash,
		}
		
		scriptDict = { 	CIVILIZATION_IMMIGRATION_DATA : civilizationImmigrationHash }

		# Initialize the actual entity. 
		sdEntityInit("Immigration Mod", iPlayerID, scriptDict)

		return True